#ifndef __CMatrix__
#define __CMatrix__
#include "CVector.h"

class CMatrix {
protected:
	int numberOfRows ;
	CVector* rows;
public :
	CMatrix() ;
	~CMatrix() ;
	CMatrix(int, int, double = 0.0) ;
	CMatrix(const CMatrix&) ;
	CMatrix& operator+(const CMatrix&) const ;
	CMatrix& operator-(const CMatrix&) const ;
	CMatrix& operator-() const ;
	CMatrix& operator*(const CMatrix&) const ;
	CMatrix& operator=(const CMatrix&) ;
	CMatrix& operator/(double) const ;
	CVector& operator[](int) const ; // returns the column vector
	CMatrix& operator~() const ; // returns transpose
	double& operator()(int, int) const ;
	CMatrix& clone() const ;
	double max() const ;
	double min() const ; 
	int getRowSize() const;
	int getColumnSize() const;
	friend ostream& operator <<(ostream&, const CMatrix&);
} ;
#endif
